import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class StartupFrame extends JFrame {
	MainPanel main_panel;
	boolean is_applet;

	public StartupFrame(boolean is_applet, String init_params) {
		super("IFS");
		this.is_applet = is_applet;

		final StartupFrame f = this;
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				f.dispose();
				if(!f.is_applet) System.exit(0);
			}
		});

		main_panel = new MainPanel(init_params, is_applet);

		getContentPane().setLayout(new GridLayout(1, 1));
		getContentPane().add(main_panel);
		getContentPane().validate();
		pack();
		setSize(950, 700);
		setVisible(true);
	}

	public void dispose() {
		if(main_panel != null) main_panel.dispose();
	}
}
